﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Xml;
using System.IO;
using System.Xml.Serialization;
using System.Xml.Linq;
using System.Threading;

/* ndXml v0.8 (c) Jeff Albrecht July 27, 2011


 * 
 * Licensing: If you can make money off of this I want some too! Otherwise learn, share and feed back if ya want. 
 * 
 * Based on some code from wp7 ePhidgetY http://www.appdevpro.com that reads and displays similar XML produced
 * by Phidgets controller. nerdDoro is my learning project to replace Phidget with Parallax technology.

endlessly
  Read XML file produced by Spinneret embedded propeller powered web server containing current time and temperature data.
  Persist a row of this data to db.

Sample XML from the Spinneret http://10.9.8.150/xml or http://jeffa.org:90/xml :

<?xml version="1.0" encoding="UTF-8"?>
<nerdDoroData xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">       
  <currentTemperature0>78.1</currentTemperature0>
  <currentMeasuredTime>2011-07-27T07:50:15</currentMeasuredTime>
</nerdDoroData>

Research resources
 
 http://www.dreamincode.net/forums/topic/151783-reading-xml-from-url/
 http://www.dreamincode.net/forums/topic/34323-c%23-faq/
 http://www.dreamincode.net/forums/topic/114565-read-in-xml-file-from-internet/page__p__701013&#entry701013
 http://stackoverflow.com/questions/4025072/nullreferenceexception-on-this-c-code

 error handling
 http://www.albahari.com/nutshell/ch14.aspx

 xmlns error
 http://social.msdn.microsoft.com/Forums/en/netfxremoting/thread/462e9d82-b6f2-4f1b-95c4-bc49c7ca7006

*/

namespace ndXml {

    class Program {

#region public defines

        public static WebClient ndWebClient = new WebClient();
        public static Stream ndData;
        public static XmlReader ndxRdr;

#endregion

        static void Main(string[] args) {

            nerdDoro ndRec = new nerdDoro();        // ef model to persist to db

            Console.WriteLine("Read nerdDoroData XML from web");

            // endlessly read the nerdDoro XML time and temperature
            while (true) { 

                try {

                    // Set the Xml root specifically. Never could find why the deserializer didn't like my XML
                    // php didn't complain. 
                    XmlRootAttribute ndRoot = new XmlRootAttribute();
                    ndRoot.ElementName = "nerdDoroData";
                    ndRoot.IsNullable = true;

                    // read the XML from nerdDoro Spinneret
                    ndData = ndWebClient.OpenRead("http://10.9.8.150/xml");

                    ndxRdr = XmlReader.Create(new StreamReader(ndData));
                    XmlSerializer ndSer = new XmlSerializer(typeof(nerdDoroData), ndRoot);
                    nerdDoroData nd = (nerdDoroData)ndSer.Deserialize(ndxRdr);

                    Console.Write("At: " + nd.currentMeasuredTime);
                    Console.WriteLine(" nerdDoro says the inside temperature is: " + nd.currentTemperature0);

                     
#region Persist new row of deserialized nerdDoroData to the db.

                    var doro = new nerdDoroData {

                        currentMeasuredTime = nd.currentMeasuredTime,
                        currentTemperature0 = nd.currentTemperature0
                    };

                    ndRec.NerdDoros.Add(doro);
                    ndRec.SaveChanges();
#endregion
                    // clean up 
                    ndData.Close();
                    ndData.Dispose();
                    ndxRdr.Close();

                    // collect and record data every 5 seconds
                    Thread.Sleep(5000);
                }

#region catch that try

                catch (TimeoutException timeOutE) {

                    Console.WriteLine("\n\r{0} TimeoutException Exception caught.", timeOutE);
                }

                catch (WebException webEx) {

                    Console.WriteLine("Caught: (WebException webEx)");
                }

                catch (XmlException xmlEx) {

                    // Console.WriteLine("\n\r{0} XmlException Exception caught.", xmlEx);
                    Console.WriteLine("Caught: (XmlException xmlEx)");
                }

                catch (Exception e) {

                    Console.WriteLine("\n\r{0} Exception caught.", e);
                }

                finally {

                    ndData.Close();
                    ndData.Dispose();
                    ndxRdr.Close();
                }
#endregion
            }
        }
    }
}
